unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.TeEngine,
  Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, VCLTee.Series, Vcl.StdCtrls, System.TypInfo;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TBarSeries;
    Series2: TBarSeries;
    Series3: TBarSeries;
    Series4: TBarSeries;
    Memo1: TMemo;
    Memo2: TMemo;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;



var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TMyBar=class(TBarSeries) // custom series to set different custom "X" values
public
  function MinXValue:Double; override;
end;

Function TMyBar.MinXValue:Double;
Begin
  if (MultiBar=mbStacked) and (Count>0) then
    result:=XValue[0] // <-- return the first point "X" value as the horizontal location
  else
    result:=inherited MinXValue;
end;

procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  Pos: TPoint;
  Part: TChartClickedPart;

  I: Integer;
  Clicked: Integer;
begin
  Pos := Point(X, Y);

  Memo2.Lines.Clear;

  for I := 0 to Chart1.SeriesCount - 1 do
  Begin
    Clicked := Chart1.Series[I].Clicked(X, Y);

    Memo2.Lines.Add(IntToStr(I) + ' ' + IntToStr(Clicked))

  End;
    

  Chart1.CalcClickedPart(Pos, Part);
  if Part.Part = cpNone then Exit;
  Memo1.Lines.Clear;
  Memo1.Lines.Add(GetEnumName(TypeInfo(TChartClickedPartStyle), Integer(Part.Part)));

end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Chart1.View3D := CheckBox1.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  b1: TMyBar;
  b2: TMyBar;
  b3: TMyBar;
  b4: TMyBar;

begin

  b1 := TMyBar.Create(Self);
  b2 := TMyBar.Create(Self);
  b3 := TMyBar.Create(Self);
  b4 := TMyBar.Create(Self);

  Chart1.SeriesList.Clear;

  Chart1.AddSeries(b1);
  Chart1.AddSeries(b2);
  Chart1.AddSeries(b3);
  Chart1.AddSeries(b4);

  b1.MultiBar := mbStacked;

  Chart1.Series[0].AddXY(0, 1, 'Label1', $00FF00);
  Chart1.Series[1].AddXY(0, 2, 'Label2', $0000FF);
  Chart1.Series[2].AddXY(0, 3, 'Label3', $00FFFF);
  Chart1.Series[3].AddXY(0, 1, 'Label4', $FF0000);

  Chart1.Series[0].AddXY(1, 1, 'Label1', $00FF00);
  Chart1.Series[1].AddXY(1, 2, 'Label2', $0000FF);
  Chart1.Series[2].AddXY(1, 1, 'Label3', $00FFFF);
  Chart1.Series[3].AddXY(1, 1, 'Label4', $FF0000);

  Chart1.Series[0].AddXY(2, 5, 'Label1', $00FF00);
  Chart1.Series[1].AddXY(2, 2, 'Label2', $0000FF);
  Chart1.Series[2].AddXY(2, 1, 'Label3', $00FFFF);
  Chart1.Series[3].AddXY(2, 3, 'Label4', $FF0000);

  //b1.XValues[0] := 0.5;

end;

end.
